{{ form_start(form) }}
<div>
    {{ form_errors(form) }}
</div>
{{ form_row(form.username) }}
{{ form_row(form.name) }}
{{ form_row(form.email) }}
{{ form_row(form.loginType) }}
{{ form_row(form.accessUser.openid) }}
{{ form_row(form.accessUser.ldap) }}
<div class="search-engine-container form-group search-engine">
    {{ form_row(form.accessUser.ldapUsername, {'attr': {'autocomplete': 'off'}}) }}
    <div id="ldap-search" class="dropdown-menu">
        <ul class="search-bar-results"></ul>
    </div>
</div>

{{ form_row(form.notifyUserRegistration) }}
<button type="submit" class="btn btn-primary hide">Hidden submit</button>
{{ form_end(form) }}

<script>
    var ldapUsername = $('#{{ form.accessUser.ldapUsername.vars.id }}');
    var ldapDropdown = $('#ldap-search').dropdown('hide');
    var ldapDropdownResults = ldapDropdown.find('ul');
    var openidSelect = $('#{{ form.accessUser.openid.vars.id }}');
    var ldapSelect = $('#{{ form.accessUser.ldap.vars.id }}');

    var searchButton = $('<button type="button" class="submit-search-engine">')
        .append($('<span class="sr-only">').text("Rechercher"))
        .append($('<i class="fa fa-search" aria-hidden="true">'))
        .on('click', function (event) {
            // .dropdown('toggle') ne fonctionne pas...
            if (ldapDropdown.hasClass('show')) {
                ldapDropdown.dropdown('hide');
            } else {
                ldapDropdown.dropdown('show');
            }
        })
    ;
    searchButton.insertAfter(ldapUsername);

    $('#{{ form.loginType.vars.id }}').on('change.user-form', function() {
        let value = $(this).val();
        let form = $(this).closest('form');
        let ldap = form.find('.type-ldap');
        let openid = form.find('.type-openid');

        ldap.hide().find('select, input').disable();
        openid.hide().find('select').disable();
        switch (value) {
            case 'refae':
                break;
            case 'ldap':
                ldap.show().find('select, input').enable();
                break;
            case 'openid':
                openid.show().find('select, input').enable();
                break;
        }
    }).trigger('change.user-form');

    ldapUsername.on('keyup.user-form change.user-form', function() {
        var value = $(this).val();
        var ldapSelect = $('#{{ form.accessUser.ldap.vars.id }}');
        var ldapId = ldapSelect.val();
        var ldap = ldapSelect.find('option[value="' + ldapId + '"]').data();
        if (!ldap) {
            return;
        }
        var field = ldap.ldapMapLogin;

        if ($(this).data('last-value') !== value) {
            $(this).data('last-value', value);
        } else {
            return;
        }

        ldapDropdown.dropdown('show');
        ldapDropdownResults
            .empty()
            .append('<li><i aria-hidden="true" class="fa fa-spinner fa-spin animated ml-2"></i></li>');
        if (!value) {
            field = ldap.ldapMapUsername;
            value = $(this).data('username');
        } else if (value.length < 3) {
            return;
        }
        $.ajax({
            url: '{{ url('admin_ldap_search', {'id': '%s'}) }}'.format(ldapId),
            method: 'POST',
            data: {
                field: field,
                value: value,
                currentLdapUsername: '{{ form.accessUser.ldapUsername.vars.value }}',
            },
            success: function (content) {
                ldapDropdownResults.empty();
                for (let i = 0; i < content.length; i++) {
                    $('<li class="search-result">').text(content).appendTo(ldapDropdownResults);
                }
            },
            complete: function () {
                ldapDropdownResults.find('.fa-spinner').parent().remove();
                if (ldapDropdownResults.find('li').length === 0) {
                    ldapDropdown.dropdown('hide');
                }
            }
        });
    });

    ldapDropdownResults.on('click.selectSearchResult', '.search-result', function(event) {
        event.preventDefault();
        ldapUsername.val($(this).text());

        setTimeout(() => ldapDropdown.dropdown('hide'), 100);
        return false;
    });
</script>
